// These are all odd .h files.  I'm using them to help structure the code.
// Normally, if I wanted to structure code this way, I'd use subroutines,
// and I'd perhaps put each subroutine in its own .c file, and have a .h file
// (or files) that defined the interfaces for those routines.
//
// For measurement, I don't want to include the overhead of calling a procedure
// (unless that's what I'm measuring).  So, instead of procedures, I use
// preprocessor macros.  That way the file with the mainline isn't gigantic,
// I can organize the code into as many distinct files as I want, but I
// don't have to call any procedures.

// These macros are used by other macros
#define START  timer_start(timer);
#define STOP   timer_stop(timer);
#define PRINT( m, LOOPCNT ) printf( "\t" #m ":\n\t  Total: %.10f seconds\n\t  Per Iteration: %.10f seconds\n", timer_elapsed(timer), timer_elapsed(timer)/LOOPCNT);
  
#define TIME( CODE, LOOPCNT)                  \
  CODE

