#ifndef MEMTESTS_H
#define MEMTESTS_H

#define ARRAYSIZE (128*1024*1024)

int bigArray[ARRAYSIZE];

// We try to do the same amount of computation per iteration
// in all variants, leading us to update variables that aren't
// even used.
// Warning: if you turn on comiler optimization, it may notice and
// get rid of the code when it has no effect

#define TEMPLOCALITY( LOOPCNT )                \
  unsigned int index = 0;                      \
  unsigned int stride = 0;                     \
  START                                        \
  for ( i=0; i<LOOPCNT; i++ ) {		       \
    bigArray[index]++;			       \
    index = (index+stride) % ARRAYSIZE;	       \
  }                                            \
  STOP                                         \
  PRINT(temporalLocality, LOOPCNT)

#define SPATIALLOCALITY( LOOPCNT )             \
  index = 0;                                   \
  stride = 1;                                  \
  START                                        \
  for (i=0; i<LOOPCNT; i++) {                  \
    bigArray[index]++;                             \
    index = (index+stride) % ARRAYSIZE;	       \
  }                                            \
  STOP                                         \
  PRINT(spatialLocality, LOOPCNT)
  
#define STRIDE32LOCALITY( LOOPCNT )            \
  index = 0;                                   \
  stride = 32;                                 \
  START                                        \
  for (i=0; i<LOOPCNT; i++) {		       \
    bigArray[index]++;                         \
    index  = (index+stride) % ARRAYSIZE;       \
  }                                            \
  STOP                                         \
  PRINT(stride32Locality, LOOPCNT)

#define STRIDE63LOCALITY( LOOPCNT )            \
  index = 0;                                   \
  stride = 63;                                  \
  START                                        \
  for (i=0; i<LOOPCNT; i++) {		       \
    bigArray[index]++;                         \
    index  = (index+stride) % ARRAYSIZE;       \
  }                                            \
  STOP                                         \
  PRINT(stride63Locality, LOOPCNT)

#define RANDOMLOCALITY( LOOPCNT, TID )         \
  START                                        \
  index = 0;                                   \
  stride = 111 * TID;                          \
  for (i=0; i<LOOPCNT; i++) {		       \
    bigArray[index]++;                         \
    index  = (index+stride) % ARRAYSIZE;       \
  }                                            \
  STOP                                         \
  PRINT(randomLocality, LOOPCNT)

#endif // MEMTESTS_H
