#ifndef MY_SYSCALL_H
#define MY_SYSCALL_H

#include <unistd.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <fcntl.h>

#define SYSCALL_PID(LOOPCNT)          \
  START                               \
  for (i=0; i<LOOPCNT; i++)           \
     syscall(SYS_getpid);             \
  STOP                                \
  PRINT(syscall getpid, LOOPCNT)

#define SYSCALL_OPEN_CLOSE(LOOPCNT)   \
  int fd;                             \
  START                               \
  for (i=0; i<LOOPCNT; i++) {         \
    fd = open("/usr/include/xorg/callback.h", 0, O_RDONLY); \
    if ( fd >= 0 ) close(fd);         \
  }                                   \
  STOP                                \
  PRINT(open/close, LOOPCNT)
  
#define SYSCALL_FOPEN_FCLOSE(LOOPCNT) \
  FILE *f;                            \
  START                               \
  for (i=0; i<LOOPCNT; i++) {         \
    f = fopen("./driver.c", "r");     \
    if ( f ) fclose(f);               \
  }                                   \
  STOP                                \
  PRINT(fopen/fclose, LOOPCNT);
  
#define SYSCALL_FORK_WAIT(LOOPCNT)    \
  pid_t childPID;                     \
  START                               \
  for (i=0; i<LOOPCNT; i++) {         \
    childPID = fork();                \
    if ( !childPID ) _exit(1);	      \
    waitpid(childPID, NULL, 0);       \
  }                                   \
  STOP                                \
  PRINT(fork, LOOPCNT);

void *dummy(void*);
  
#define THREAD_CREATE_JOIN(LOOPCNT)   \
  pthread_t childThread;              \
  START                               \
  for (i=0; i<LOOPCNT; i++) {         \
    if (!pthread_create(&childThread, NULL, dummy, NULL))	\
       pthread_join(childThread, NULL);\
  }                                   \
  STOP                                \
  PRINT(thread create/join, LOOPCNT)
  


#endif // MY_SYSCALL_H
